<?php

/*
CLASSE COPIADA COM MODIFICAÇÕES DA DEPENDENCIA 'TEKNISA/LIBRARIES' VERSÃO: '3.0.24'. NAMESPACE ORIGINAL 'Teknisa\Libs\Util'
*/

namespace Ems\Auth;

use Doctrine\Common\Cache\Cache as CacheInterface;
use Zeedhi\Framework\Cache\Cache;
use Zeedhi\Framework\Cache\Type\MongoImpl;
// use Teknisa\Libs\Exception\Token as TokenException;
use Ems\Auth\Exception\AccessException;
use MongoDB\BSON\UTCDateTime as MongoDate;

class MongoImplCustom extends MongoImpl implements Cache, CacheInterface
{
    /**
     * {@inheritdoc}
     */
    public function fetch($key, $lifeTime = 0, $keepConnected = false) {
        $documents = $this->mongo->find($this->getCollectionName(), array('_id' => $key));
        $document = array_shift($documents);

        if ($document === null) {
            AccessException::invalidToken($key);
        }

        if ($this->isExpired($document) && !$keepConnected) {
            $this->delete($key);
            AccessException::expiredToken($key);
        }

        $docParams = unserialize($document[self::DATA_FIELD]->getData());
        $this->save($key, $docParams, $lifeTime);
        return $docParams;
    }

    /**
     * Check if the document is expired.
     *
     * @param array $document
     *
     * @return boolean
     */
    protected function isExpired(array $document) {
        return isset($document[self::EXPIRATION_FIELD]) &&
               $document[self::EXPIRATION_FIELD] instanceof MongoDate &&
               intval($document[self::EXPIRATION_FIELD]->__toString()) < time();
    }
}