create or replace
PROCEDURE CCH_IMPORTA_CLIENTE_SAP
IS
   V_CDPAIS      INTEGER;
   V_SGESTADO    INTEGER;
   V_CLIENTE     INTEGER;
   V_CDMUNICIPIO VARCHAR2(7);
   V_FORMPGTO    INTEGER;
   V_BAIRRO      VARCHAR2(10);
   V_NMBAIRRO    VARCHAR2(50);
   V_REGIAOMUNI  VARCHAR2(4);
BEGIN
   FOR C_CLIENTE IN
       (SELECT /*CLIENTE*/
               U.CDCLIENTE, U.NMRAZAOSOC, U.NMFANTCLIE, U.IDTPIJURCLIE, U.NRINSJURCLIE, U.NRINSESTCLIE, U.CDFORMPGTO, U.IDTPFORPGTCL,
               U.NRPARCPGTOCL, U.NRDIAPGFIXCL, U.IDUTDIAPGTCL, U.CDCSTDIG1CLI, NVL(U.IDENDEMISCLI, 'P') AS IDENDEMISCLI, NVL(U.IDENDCFOPCLI, 'P') AS IDENDCFOPCLI, U.IDTIPINFCOME, U.DTCADACLIE,
               U.IDCLIECONTRI, U.IDCLIEATIV, U.IDSEGCLIP, U.IDTERCLIP, U.IDQUACLIP, U.IDQUICLIP, U.IDSEXCLIP, U.IDSABCLIP, U.IDDOMCLIP,
               U.IDRECINFMKT, NVL(U.IDPRIPUBCLIE, 'V') AS IDPRIPUBCLIE, NVL(U.IDVERSALDCLI, 'N') AS IDVERSALDCLI,
               NVL(U.IDUTSALDCLI, 'N') AS IDUTSALDCLI, NVL(U.IDCALCDVCLIE, '1') AS IDCALCDVCLIE, NVL(U.IDUTSUBCLIEN, 'N') AS IDUTSUBCLIEN,
               NVL(U.IDLIBGERPER, 'N') AS IDLIBGERPER, NVL(U.IDZERSALDCON, 'S') AS IDZERSALDCON,
               NVL(U.IDGERNFCLIE, '1') AS IDGERNFCLIE, NVL(U.IDSITFINCLIE, 'N') AS IDSITFINCLIE, NVL(U.IDLIGEXTCLIE, 'S') AS IDLIGEXTCLIE,
               U.IDCLIEAUTO, U.IDGERANFPEDI, U.IDUTCONSPEDI, U.NMCOMPRZSCLI, U.CDEXCLIENTE,
               /*ENDECLIE*/
               U.DSENDERECOP, U.CDPAISP, U.SGESTADOP, SUBSTR(U.CDMUNICIPIOP, 3, 5) AS CDMUNICIPIOP, U.CDCEPP, U.NMBAIRROP, U.EMAIL,
               /*USR_SAP_CLIENTE*/
               U.IDINTERFACE, U.TPINTERFACE
          FROM USR_SAP_CLIENTE U
         WHERE U.DTINTERFACEDEST IS NULL
         ORDER BY U.DTINTERFACEORI)
   LOOP
      V_BAIRRO     := NULL;
      V_NMBAIRRO   := NULL;
      V_REGIAOMUNI := NULL;

      SELECT COUNT(1) AS CDPAIS 
        INTO V_CDPAIS
        FROM PAIS
       WHERE CDPAIS = C_CLIENTE.CDPAISP;

      IF V_CDPAIS > 0 THEN
         SELECT COUNT(1) AS SGESTADO
           INTO V_SGESTADO
           FROM ESTADO
          WHERE CDPAIS   = C_CLIENTE.CDPAISP
            AND SGESTADO = C_CLIENTE.SGESTADOP;

         IF V_SGESTADO > 0 THEN
            BEGIN
               SELECT MAX(CDMUNICIPIO) CDMUNICIPIO
                 INTO V_CDMUNICIPIO
                 FROM MUNICIPIO
                WHERE CDPAIS     = C_CLIENTE.CDPAISP
                  AND SGESTADO   = C_CLIENTE.SGESTADOP
                  AND CDMUNIEXPO = C_CLIENTE.CDMUNICIPIOP;

               IF V_CDMUNICIPIO IS NOT NULL THEN
                  V_NMBAIRRO := TRIM(C_CLIENTE.NMBAIRROP);

                  IF V_NMBAIRRO IS NOT NULL THEN
                     BEGIN
                        SELECT MAX(CDBAIRRO) CDBAIRRO
                          INTO V_BAIRRO
                          FROM BAIRRO
                         WHERE CDPAIS      = C_CLIENTE.CDPAISP
                           AND SGESTADO    = C_CLIENTE.SGESTADOP
                           AND CDMUNICIPIO = V_CDMUNICIPIO
                           AND UPPER(TRIM(NMBAIRRO)) = UPPER(V_NMBAIRRO);
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_BAIRRO := '';
                     END;

                     IF NVL(V_BAIRRO, 'NOVO') = 'NOVO' THEN
                        SELECT B.NRBAIRRO
                          INTO V_BAIRRO
                          FROM (SELECT LPAD(NVL(MAX(CDBAIRRO),0)+1,10,'0') AS NRBAIRRO
                                  FROM BAIRRO
                                 WHERE CDPAIS      = C_CLIENTE.CDPAISP
                                   AND SGESTADO    = C_CLIENTE.SGESTADOP
                                   AND CDMUNICIPIO = V_CDMUNICIPIO) B;
                        BEGIN
                           SELECT CDREGIAOMUNI
                             INTO V_REGIAOMUNI
                             FROM REGIAOMUNI
                            WHERE CDPAIS       = C_CLIENTE.CDPAISP
                              AND SGESTADO     = C_CLIENTE.SGESTADOP
                              AND CDMUNICIPIO  = V_CDMUNICIPIO
                              AND CDREGIAOMUNI = '9999';
                        EXCEPTION
                           WHEN NO_DATA_FOUND THEN
                              V_REGIAOMUNI := '';
                        END;
                         IF NVL(V_REGIAOMUNI, 'NOVO') = 'NOVO' THEN
                           INSERT INTO REGIAOMUNI
                           (CDPAIS, SGESTADO, CDMUNICIPIO, CDREGIAOMUNI, NMREGIAOMUNI)
                           VALUES
                           (C_CLIENTE.CDPAISP, C_CLIENTE.SGESTADOP, V_CDMUNICIPIO, '9999', '9999');
                        END IF;
                         INSERT INTO BAIRRO
                        (CDPAIS, SGESTADO, CDMUNICIPIO, CDREGIAOMUNI, CDBAIRRO, NMBAIRRO)
                        VALUES
                        (C_CLIENTE.CDPAISP, C_CLIENTE.SGESTADOP, V_CDMUNICIPIO, '9999', V_BAIRRO, V_NMBAIRRO);
                     END IF;
                  END IF;
                   SELECT COUNT(1) AS CLIENTE
                    INTO V_CLIENTE
                    FROM CLIENTE
                   WHERE CDCLIENTE = C_CLIENTE.CDCLIENTE;

                  IF V_CLIENTE = 0 THEN
                     INSERT INTO CLIENTE
                        (CDCLIENTE, NMRAZSOCCLIE, NMFANTCLIE, IDTPIJURCLIE, NRINSJURCLIE, NRINSESTCLIE, CDFORMPGTO, IDTPFORPGTCL,
                         NRPARCPGTOCL, NRDIAPGFIXCL, IDUTDIAPGTCL, CDCSTDIG1CLI, IDENDEMISCLI, IDENDCFOPCLI, IDTIPINFCOME, DTCADACLIE,
                         IDCLIECONTRI, IDCLIEATIV, IDSEGCLIP, IDTERCLIP, IDQUACLIP, IDQUICLIP, IDSEXCLIP, IDSABCLIP, IDDOMCLIP,
                         IDRECINFMKT, IDPRIPUBCLIE, IDVERSALDCLI, IDUTSALDCLI, IDCALCDVCLIE, IDUTSUBCLIEN, IDLIBGERPER, IDZERSALDCON,
                         IDGERNFCLIE, IDSITFINCLIE, IDLIGEXTCLIE, IDCLIEAUTO, IDGERANFPEDI, IDUTCONSPEDI, NMCOMPRZSCLI, CDEXCLIENTE)
                     VALUES
                        (C_CLIENTE.CDCLIENTE, C_CLIENTE.NMRAZAOSOC, C_CLIENTE.NMFANTCLIE, C_CLIENTE.IDTPIJURCLIE, C_CLIENTE.NRINSJURCLIE, C_CLIENTE.NRINSESTCLIE, C_CLIENTE.CDFORMPGTO, C_CLIENTE.IDTPFORPGTCL,
                         C_CLIENTE.NRPARCPGTOCL, C_CLIENTE.NRDIAPGFIXCL, C_CLIENTE.IDUTDIAPGTCL, C_CLIENTE.CDCSTDIG1CLI, C_CLIENTE.IDENDEMISCLI, C_CLIENTE.IDENDCFOPCLI, C_CLIENTE.IDTIPINFCOME, C_CLIENTE.DTCADACLIE,
                         C_CLIENTE.IDCLIECONTRI, C_CLIENTE.IDCLIEATIV, C_CLIENTE.IDSEGCLIP, C_CLIENTE.IDTERCLIP, C_CLIENTE.IDQUACLIP, C_CLIENTE.IDQUICLIP, C_CLIENTE.IDSEXCLIP, C_CLIENTE.IDSABCLIP, C_CLIENTE.IDDOMCLIP,
                         C_CLIENTE.IDRECINFMKT, C_CLIENTE.IDPRIPUBCLIE, C_CLIENTE.IDVERSALDCLI, C_CLIENTE.IDUTSALDCLI, C_CLIENTE.IDCALCDVCLIE, C_CLIENTE.IDUTSUBCLIEN, C_CLIENTE.IDLIBGERPER, C_CLIENTE.IDZERSALDCON,
                         C_CLIENTE.IDGERNFCLIE, C_CLIENTE.IDSITFINCLIE, C_CLIENTE.IDLIGEXTCLIE, C_CLIENTE.IDCLIEAUTO, C_CLIENTE.IDGERANFPEDI, C_CLIENTE.IDUTCONSPEDI, C_CLIENTE.NMCOMPRZSCLI, C_CLIENTE.CDEXCLIENTE);

                     /*Endereo principal*/
                     INSERT INTO ENDECLIE
                        (CDCLIENTE, DSENDECLIE, CDPAIS, SGESTADO, CDMUNICIPIO, NRCEPCLIE,
                         NMBAIRCLIE, DSEMAILCLIE, IDTPENDECLIE, CDBAIRRO)
                     VALUES
                        (C_CLIENTE.CDCLIENTE, C_CLIENTE.DSENDERECOP, C_CLIENTE.CDPAISP, C_CLIENTE.SGESTADOP, V_CDMUNICIPIO, C_CLIENTE.CDCEPP,
                         V_NMBAIRRO, C_CLIENTE.EMAIL, 'P', V_BAIRRO);

                     INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                     VALUES (C_CLIENTE.IDINTERFACE, 'I', 2, SYSDATE, 0, 'Cliente '|| C_CLIENTE.CDCLIENTE || ' - ' || C_CLIENTE.NMFANTCLIE || ' registrado con xito.');
                  ELSE
                     UPDATE CLIENTE SET  NMRAZSOCCLIE = C_CLIENTE.NMRAZAOSOC, NMFANTCLIE = C_CLIENTE.NMFANTCLIE, NRINSESTCLIE = C_CLIENTE.NRINSESTCLIE, CDFORMPGTO = C_CLIENTE.CDFORMPGTO, IDTPFORPGTCL = C_CLIENTE.IDTPFORPGTCL,
                                         NRPARCPGTOCL = C_CLIENTE.NRPARCPGTOCL, NRDIAPGFIXCL = C_CLIENTE.NRDIAPGFIXCL, IDUTDIAPGTCL = C_CLIENTE.IDUTDIAPGTCL, CDCSTDIG1CLI = C_CLIENTE.CDCSTDIG1CLI, IDENDEMISCLI = C_CLIENTE.IDENDEMISCLI, IDENDCFOPCLI = C_CLIENTE.IDENDCFOPCLI, IDTIPINFCOME = C_CLIENTE.IDTIPINFCOME, DTCADACLIE = C_CLIENTE.DTCADACLIE,
                                         IDCLIECONTRI = C_CLIENTE.IDCLIECONTRI, IDCLIEATIV = C_CLIENTE.IDCLIEATIV, IDSEGCLIP = C_CLIENTE.IDSEGCLIP, IDTERCLIP = C_CLIENTE.IDTERCLIP, IDQUACLIP = C_CLIENTE.IDQUACLIP, IDQUICLIP = C_CLIENTE.IDQUICLIP, IDSEXCLIP = C_CLIENTE.IDSEXCLIP, IDSABCLIP = C_CLIENTE.IDSABCLIP, IDDOMCLIP = C_CLIENTE.IDDOMCLIP,
                                         IDRECINFMKT = C_CLIENTE.IDRECINFMKT, IDPRIPUBCLIE = C_CLIENTE.IDPRIPUBCLIE, IDVERSALDCLI = C_CLIENTE.IDVERSALDCLI, IDUTSALDCLI = C_CLIENTE.IDUTSALDCLI, IDCALCDVCLIE = C_CLIENTE.IDCALCDVCLIE, IDUTSUBCLIEN = C_CLIENTE.IDUTSUBCLIEN, IDLIBGERPER = C_CLIENTE.IDLIBGERPER, IDZERSALDCON = C_CLIENTE.IDZERSALDCON,
                                         IDGERNFCLIE = C_CLIENTE.IDGERNFCLIE, IDSITFINCLIE = C_CLIENTE.IDSITFINCLIE, IDLIGEXTCLIE = C_CLIENTE.IDLIGEXTCLIE, IDCLIEAUTO = C_CLIENTE.IDCLIEAUTO, IDGERANFPEDI = C_CLIENTE.IDGERANFPEDI, IDUTCONSPEDI = C_CLIENTE.IDUTCONSPEDI, NMCOMPRZSCLI = C_CLIENTE.NMCOMPRZSCLI,
                                         CDEXCLIENTE = C_CLIENTE.CDEXCLIENTE
                      WHERE CDCLIENTE = C_CLIENTE.CDCLIENTE;

                     UPDATE ENDECLIE SET DSENDECLIE = C_CLIENTE.DSENDERECOP, CDPAIS = C_CLIENTE.CDPAISP, SGESTADO = C_CLIENTE.SGESTADOP, CDMUNICIPIO = V_CDMUNICIPIO,
                                         NRCEPCLIE = C_CLIENTE.CDCEPP, NMBAIRCLIE = V_NMBAIRRO, DSEMAILCLIE = C_CLIENTE.EMAIL, CDBAIRRO = V_BAIRRO
                      WHERE CDCLIENTE = C_CLIENTE.CDCLIENTE;

                     INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                     VALUES (C_CLIENTE.IDINTERFACE, 'A', 2, SYSDATE, 0, 'Cliente '|| C_CLIENTE.CDCLIENTE || ' - ' || C_CLIENTE.NMFANTCLIE || ' registrado con xito.');
                  END IF;

                  UPDATE USR_SAP_CLIENTE SET DTINTERFACEDEST = SYSDATE, STATUS = 0
                  WHERE IDINTERFACE = C_CLIENTE.IDINTERFACE;
               ELSE
                  V_CDMUNICIPIO := '';
                  INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                  VALUES (C_CLIENTE.IDINTERFACE, 'I', 2, SYSDATE, 1, 'C'||CHR(243)||'digo de exportacin  '||C_CLIENTE.CDMUNICIPIOP ||', relacionado a el cliente ' || C_CLIENTE.CDCLIENTE || ' - ' || C_CLIENTE.NMFANTCLIE || ', n'||CHR(227)||'no registrado en el sistema Teknisa.');

                  UPDATE USR_SAP_CLIENTE SET STATUS = 2
                   WHERE IDINTERFACE = C_CLIENTE.IDINTERFACE;
               END IF;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_CDMUNICIPIO := '';
                  INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                  VALUES (C_CLIENTE.IDINTERFACE, 'I', 2, SYSDATE, 1, 'C'||CHR(243)||'digo de exportacin  '||C_CLIENTE.CDMUNICIPIOP ||', relacionado a el cliente ' || C_CLIENTE.CDCLIENTE || ' - ' || C_CLIENTE.NMFANTCLIE || ', n'||CHR(227)||'no registrado en el sistema Teknisa.');

                  UPDATE USR_SAP_CLIENTE SET STATUS = 2
                   WHERE IDINTERFACE = C_CLIENTE.IDINTERFACE;
            END;
         ELSE
            INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
            VALUES (C_CLIENTE.IDINTERFACE, 'I', 2, SYSDATE, 1, 'Sigla de el estado '|| C_CLIENTE.SGESTADOP ||', relacionado a el cliente ' || C_CLIENTE.CDCLIENTE || ' - ' || C_CLIENTE.NMFANTCLIE || ', n'||CHR(227)||'no registrado en el sistema Teknisa.');

            UPDATE USR_SAP_CLIENTE SET STATUS = 2
             WHERE IDINTERFACE = C_CLIENTE.IDINTERFACE;
         END IF;
      ELSE
         INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
         VALUES (C_CLIENTE.IDINTERFACE, 'I', 2, SYSDATE, 1, 'C'||CHR(243)||'digo do pa'||CHR(237)||'s '||C_CLIENTE.CDPAISP || ', relacionado a el cliente '|| C_CLIENTE.CDCLIENTE || ' - ' || C_CLIENTE.NMFANTCLIE ||', n'||CHR(227)||'no registrado en el sistema Teknisa.');
         
         UPDATE  USR_SAP_CLIENTE SET STATUS = 2
          WHERE IDINTERFACE = C_CLIENTE.IDINTERFACE;
      END IF;
   END LOOP;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CCH_IMPORTA_CLIENTE_SAP','6.49.044'); END;
/
